﻿using Prism.Mvvm;
using Prism.Navigation;
using System.Windows.Input;
using Xamarin.Forms;

namespace Borepin.PageModel.AddServerProcess
{
    public class LoginChoosePageModel : BindableBase
    {
        private INavigationService _NavigationService;

        public LoginChoosePageModel(INavigationService navigationService)
        {
            _NavigationService = navigationService;

            LoginPasswordCommand = new Command(LoginPasswordCommandExecuted);
        }

        private ICommand _LoginPasswordCommand;
        public ICommand LoginPasswordCommand
        {
            get => _LoginPasswordCommand;
            set => SetProperty(ref _LoginPasswordCommand, value);
        }

        private async void LoginPasswordCommandExecuted()
        {
            INavigationResult result = await _NavigationService.NavigateAsync("AddServerProcess_LoginPasswordPage");
            if (!result.Success)
            {
                System.Diagnostics.Debugger.Break();
            }
        }
    }
}
