﻿using Borepin.Model;
using System;
using System.Threading.Tasks;

namespace Borepin.Service.Credentials
{
    public class CredentialService : ICredentialService
    {
        #region Private Properties
        private readonly ISecretService _SecretService;
        #endregion

        #region Constructors
        public CredentialService(ISecretService secretService)
        {
            _SecretService = secretService;
        }
        #endregion

        public async Task<string> GetPasswordAsync(Connection connection)
        {
            if (connection.AuthenticationTyp != AuthenticationTyp.PLAIN)
            {
                throw new ArgumentException("AuthenticationTyp is not PLAIN");
            }

            return await _SecretService.GetAsync(string.Format("bffh_password_{0}_{1}", connection.Address.ToString(), connection.Username));
        }

        public async Task<bool> AddCredentialsAsync(Connection connection, string password)
        {
            await _SecretService.SetAsync(string.Format("bffh_password_{0}_{1}", connection.Address.ToString(), connection.Username), password);

            return await Task.FromResult(true);
        }

        public async Task<bool> RemoveCredentialsAsync(Connection connection)
        {
            _SecretService.Remove(string.Format("bffh_password_{0}_{1}", connection.Address.ToString(), connection.Username));
            
            return await Task.FromResult(true);
        }
    }
}
